"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.plugin = void 0;
const package_utils_1 = require("@monorepo-utils/package-utils");
exports.plugin = (options) => {
    // getPackages support "workspaces" and lerna.json
    const monorepoPackages = package_utils_1.getPackages(options.rootDir);
    return {
        supports() {
            return monorepoPackages.length > 0;
        },
        getAllPackages() {
            return monorepoPackages;
        },
        getDependencies(packageJSON) {
            var _a, _b;
            const dependencies = Object.entries((_a = packageJSON.dependencies) !== null && _a !== void 0 ? _a : {});
            const devDependencies = Object.entries((_b = packageJSON.devDependencies) !== null && _b !== void 0 ? _b : {});
            return [...dependencies, ...devDependencies].map((dep) => {
                return {
                    name: dep[0]
                };
            });
        },
        resolve({ name }) {
            const matchPkg = monorepoPackages.find((info) => {
                return info.packageJSON.name === name;
            });
            if (!matchPkg) {
                return null;
            }
            return matchPkg.location;
        }
    };
};
//# sourceMappingURL=workspaces.js.map